/*
 * clock.hpp
 *
 *  Created on: 13 . 2023 .
 *      Author: sychev
 */

#ifndef FREE_RTOS_CLOCK_CLOCK_HPP_
#define FREE_RTOS_CLOCK_CLOCK_HPP_

#include <kernel/dpl/ClockP.h>

namespace free_rtos {

class Clock {
public:
    using Callback = void(*)(ClockP_Object *,void *);

    bool init(uint32_t period_ms, Callback cbk, void * arg);

    void start();

    void stop();

    uint32_t getPeriod() {
        return prd_ms_;
    }

    ~Clock();
private:
    ClockP_Object obj_;
    uint32_t prd_ms_; ///   
};


}


#endif /* FREE_RTOS_CLOCK_CLOCK_HPP_ */
